on startMovie
  ResetGlobals()
  set wind to MyTutorWindow()
  if not voidp(wind) then
    set the title of wind to "Learning Director"
    set the windowType of wind to 4
  end if
  SG(#gLessonList, getlist("@LessonList#field", "AuthorData"))
  SG(#gIsSmallWindow, 0)
  if the machineType < 256 then
    SetField("CurrentLessonSteps#field", EMPTY, "Geneva", 9, "plain")
    SetField("LineBreakTester#field", EMPTY, "Geneva", 9, "plain")
    SetField("MenuPlaceHolder#field", EMPTY, "Geneva", 9, "plain")
  else
    SetField("CurrentLessonSteps#field", EMPTY, "MS Sans Serif", 9, "plain")
    SetField("LineBreakTester#field", EMPTY, "MS Sans Serif", 9, "plain")
    SetField("MenuPlaceHolder#field", EMPTY, "MS Sans Serif", 9, "plain")
  end if
  VOlist()
end

on stopMovie
  go(7818)
  set wind to MyTutorWindow()
  puppetSound(1, 0)
  puppetSound(2, 0)
  sound stop 1
  sound stop 2
  if count(the windowList) < 2 then
    clearGlobals()
  end if
end

on MyTutorWindow
  set w to MyWindow()
  if voidp(w) then
    set w to the activeWindow
  end if
  return w
end

on closeWindow
  go(7818)
  puppetSound(1, 0)
  puppetSound(2, 0)
  sound stop 1
  sound stop 2
  if count(the windowList) < 2 then
    clearGlobals()
  end if
  forget(the activeWindow)
end

on idle
end

on DoQuit
  halt()
end
