global gglobals

on SG globalSymbol, val
  if voidp(gglobals) then
    set gglobals to [:]
  end if
  if not symbolp(globalSymbol) then
    alert("Bad global name" && string(globalSymbol))
    halt()
  end if
  if voidp(val) then
    deleteProp(gglobals, globalSymbol)
  else
    setaProp(gglobals, globalSymbol, val)
  end if
end

on CG globalSymbol
  if voidp(gglobals) then
    set gglobals to [:]
  end if
  if not symbolp(globalSymbol) then
    alert("Bad global name" && string(globalSymbol))
    halt()
  end if
  deleteProp(gglobals, globalSymbol)
end

on GG globalSymbol
  if voidp(gglobals) then
    set gglobals to [:]
  end if
  return getaProp(gglobals, globalSymbol)
end

on ResetGlobals
  set gglobals to getaProp([:], 1)
end

on void
  return getaProp([:], 1)
end

on VOlist
  global gFirstList, gLastList
  set gFirstList to [0: " intro.a.AIF", 1: "01.a.AIF", 2: "02.a.AIF", 3: "03.a.AIF", 4: "04.a.AIF", 5: "05.a.AIF", 6: "06.a.AIF", 7: "07.a.AIF", 8: "08.a.AIF", 9: "09.a.AIF", 10: "10.a.AIF", 11: "11.a.AIF", 12: "concl.a.AIF"]
  set gLastList to [0: " intro.g.AIF", 1: "01.08b.AIF", 2: "02.11.AIF", 3: "03.15.AIF", 4: "04.09.AIF", 5: "05.14.AIF", 6: "06.10.AIF", 7: "07.10b.AIF", 8: "08.07.AIF", 9: "09.08.AIF", 10: "10.06b.AIF", 11: "11.09.AIF", 12: "concl.e.AIF"]
end
